(vl-load-com)

(defun  infoBox(volajObj reactorObj paramList / )
  (if (vlax-property-available-p volajObj "Volume")
   (progn
    (setq objemNovy (vla-get-volume volajObj))
    (setq objemStary (vlr-data reactorObj))
    (if (> objemNovy objemStary)
      (alert
	(strcat "Objem krychle se zvtil "
		(rtos (/ objemNovy objemStary)) " krt."
        )
      )
      (alert
	(strcat "Objem krychle se zmenil "
		(rtos (/ objemStary objemNovy)) " krt."
	)
      )
    )
    (vlr-data-set reactorObj objemNovy)
   )
  )
)


(defun c:reaktorBox ()
;;; definice nov funkce spustiteln jako pkaz AutoCADu
  (setq	gl_pam_hodnoty	;;; globln promnn uchovvajc jednotliv nastaven
     (list
	(cons "stredx" "0.0")		;;; x-ova souadnice stedu kvdru
	(cons "stredy" "0.0")		;;; y-ova souadnice stedu kvdru
	(cons "stredz" "0.0")		;;; z-ova souadnice stedu kvdru
	(cons "delka"    "1")		;;; dlka kvdru
	(cons "sirka"    "1")		;;; sirka kvdru
	(cons "vyska"    "1")		;;; vyska kvdru
     )
  )

  (if	(= (rb:dialog) T)
    (rb:kresli_box)		;;; vykreslen poadovanho objektu,
      				;;; v ppad e byly zadny hodnoty sprvn
  )

  (princ "Funkce reaktor box dokonila innost")	;;; informace o ukonen funkce
  (princ)
)

 
(defun rb:dialog (/ id co_delat vysledek)
  (setq id (load_dialog "D:/dialogBox.dcl"))	;;; pedn jmna dialogovho boxu
    ;;; CESTU K UMSTN DIALOGU SE MUS AKTUALIZOVAT PODLE AKTUALNHO UMSTN
  (setq co_delat 2)
  (while (>= co_delat 2)			;;; opakuj pokud nenastane zmena
    (if	(not (new_dialog "dialogBox" id))	;;; nen-li jmno dialogu vyber tak skoni
      (exit)
    )
    ;;; nastaven hodnot dialogovch prvk
    (set_tile "delka"  (cdr (assoc "delka"  gl_pam_hodnoty)))
    (set_tile "sirka"  (cdr (assoc "sirka"  gl_pam_hodnoty)))
    (set_tile "vyska"  (cdr (assoc "vyska"  gl_pam_hodnoty)))
    (set_tile "stredx" (cdr (assoc "stredx" gl_pam_hodnoty)))
    (set_tile "stredy" (cdr (assoc "stredy" gl_pam_hodnoty)))
    (set_tile "stredz" (cdr (assoc "stredz" gl_pam_hodnoty)))

    (action_tile "stredx"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredx\" $value)
          (assoc \"stredx\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredy"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredy\" $value)
          (assoc \"stredy\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredz"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredz\" $value)
          (assoc \"stredz\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox stedu krunice nastav odpovdajc hodnoty
    (action_tile "delka"
	"(setq gl_pam_hodnoty
        (subst
          (cons \"delka\" $value)
          (assoc \"delka\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "sirka"
	"(setq gl_pam_hodnoty
        (subst
          (cons \"sirka\" $value)
          (assoc \"sirka\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "vyska"
	"(setq gl_pam_hodnoty
        (subst
          (cons \"vyska\" $value)
          (assoc \"vyska\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox nastav hodnoty

    (action_tile "stred_but" "(done_dialog 4)")
		;;; je-li zmknuto tlatko "stred_but" zavolej
    		;;; funkci done_dialog s hodnotou 4
    (action_tile "accept" "(done_dialog 1)")
		;;; je-li zmknuto tlatko "accept"
    		;;; zavolej funkci done_dialog s hodnotou 1
    (action_tile "cancel" "(done_dialog 0)")
		;;; je-li zmknuto tlatko "cancel"
    		;;; zavolej funkci done_dialog s hodnotou 0
  
    (setq co_delat (start_dialog))
		;;; nastav promnnou na hodnotu zskanou od funkce start_dialog
		;;; (hodnota s kterou kon funkce done_dialog)
    (cond	;;; uren dal innosti
      ((= co_delat 0) (setq vysledek nil))	;;; uivatel stornoval dialog = konec funce
      ((= co_delat 1) (setq vysledek T))	;;; uivatel potvrdil dialog,
      						;;; zavolej funkci (vykresli)
      ((= co_delat 4) (rb:nastav_stred (getpoint "\nVbr bodu:")))
			;;; uivatel zmkl tlatko pro zadn souadnic stedu
	    		;; zavolej funkci rb:nastav_stred
    )
  )
  (unload_dialog id)	;;; odstran dialog id z pamti
    vysledek		;;; vrcen vsledku funkce (jestli probhla OK)
)

(defun rb:nastav_stred (stred / stredx stredy stredz)
  (setq stredx (strcat (vl-princ-to-string (car stred))))
  (setq stredy (strcat (vl-princ-to-string (cadr stred))))
  (setq stredz (strcat (vl-princ-to-string (caddr stred))))

  (setq gl_pam_hodnoty
    (subst
	(cons  "stredx" stredx)
        (assoc "stredx" gl_pam_hodnoty)
	gl_pam_hodnoty
    )
  )
  (setq gl_pam_hodnoty
    (subst
	(cons  "stredy" stredy)
        (assoc "stredy" gl_pam_hodnoty)
	gl_pam_hodnoty
    )
  )
  (setq gl_pam_hodnoty
    (subst
        (cons  "stredz" stredz)
        (assoc "stredz" gl_pam_hodnoty)
        gl_pam_hodnoty
    )
  )
)

(defun rb:kresli_box (/ stred delka vyska sirka)
  (setq acadObjekt (vlax-get-acad-object)) 
  (setq acadDokument (vla-get-ActiveDocument acadObjekt))
  (setq modelProstor (vla-get-ModelSpace acadDokument)) 

  (setq stred
    (list
      (atof (cdr (assoc "stredx" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredy" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredz" gl_pam_hodnoty)))
    )
  )		;;; pevod t etzc reprezentujcch souadnice
  		;;; do promnn stred (poloky stred jsou typu float)
  (setq delka (atof (cdr (assoc "delka" gl_pam_hodnoty))))
		;;; zskn dlky krychle z asoc. seznamu gl_pam_hodnoty  
  (setq sirka (atof (cdr (assoc "sirka" gl_pam_hodnoty))))
		;;; zskn sirka krychle z asoc. seznamu gl_pam_hodnoty  
  (setq vyska (atof (cdr (assoc "vyska" gl_pam_hodnoty))))
		;;; zskn vyska krychle z asoc. seznamu gl_pam_hodnoty  

  (command)	;;; ukonen vech pedchozch pkaz
  (setq objBox
	(vla-addBox modelProstor
		 (vlax-3d-point stred) delka sirka vyska
	)
  )

  (setq objemPuvodni (vla-get-volume objBox))
  (setq boxReaktor (vlr-object-reactor (list objBox)
     objemPuvodni '((:vlr-modified . infoBox)))
  )
  (command "_zoom" "M")
)

(princ "\nFunkce se spust pkazem (c:reaktorBox) v IDE Visual LISPu")
(princ "\nFunkce se spust pkazem reaktorBox v AutoCADu")